Index: XIOS3/trunk/src/interface/fortran_attr/icontext_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/icontext_attr.F90	(revision 2614)
+++ XIOS3/trunk/src/interface/fortran_attr/icontext_attr.F90	(revision 2616)
@@ -12,5 +12,6 @@
 
   SUBROUTINE xios(set_context_attr)  &
-    ( context_id, attached_mode, output_dir )
+    ( context_id, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -19,4 +20,13 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: attached_mode
       LOGICAL (KIND=C_BOOL) :: attached_mode_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_reader
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_writer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_reader
+      LOGICAL  , OPTIONAL, INTENT(IN) :: default_using_server2
+      LOGICAL (KIND=C_BOOL) :: default_using_server2_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_writer
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: output_dir
 
@@ -24,10 +34,12 @@
       (context_id,context_hdl)
       CALL xios(set_context_attr_hdl_)   &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(set_context_attr)
 
   SUBROUTINE xios(set_context_attr_hdl)  &
-    ( context_hdl, attached_mode, output_dir )
+    ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -35,13 +47,25 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: attached_mode
       LOGICAL (KIND=C_BOOL) :: attached_mode_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_reader
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_writer
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_reader
+      LOGICAL  , OPTIONAL, INTENT(IN) :: default_using_server2
+      LOGICAL (KIND=C_BOOL) :: default_using_server2_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_writer
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: output_dir
 
       CALL xios(set_context_attr_hdl_)  &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(set_context_attr_hdl)
 
   SUBROUTINE xios(set_context_attr_hdl_)   &
-    ( context_hdl, attached_mode_, output_dir_ )
+    ( context_hdl, attached_mode_, default_gatherer_, default_pool_, default_pool_gatherer_, default_pool_reader_  &
+    , default_pool_writer_, default_reader_, default_using_server2_, default_writer_, output_dir_  &
+     )
 
     IMPLICIT NONE
@@ -49,4 +73,13 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: attached_mode_
       LOGICAL (KIND=C_BOOL) :: attached_mode__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_gatherer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_gatherer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_reader_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_pool_writer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_reader_
+      LOGICAL  , OPTIONAL, INTENT(IN) :: default_using_server2_
+      LOGICAL (KIND=C_BOOL) :: default_using_server2__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: default_writer_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: output_dir_
 
@@ -57,4 +90,45 @@
       ENDIF
 
+      IF (PRESENT(default_gatherer_)) THEN
+        CALL cxios_set_context_default_gatherer &
+      (context_hdl%daddr, default_gatherer_, len(default_gatherer_))
+      ENDIF
+
+      IF (PRESENT(default_pool_)) THEN
+        CALL cxios_set_context_default_pool &
+      (context_hdl%daddr, default_pool_, len(default_pool_))
+      ENDIF
+
+      IF (PRESENT(default_pool_gatherer_)) THEN
+        CALL cxios_set_context_default_pool_gatherer &
+      (context_hdl%daddr, default_pool_gatherer_, len(default_pool_gatherer_))
+      ENDIF
+
+      IF (PRESENT(default_pool_reader_)) THEN
+        CALL cxios_set_context_default_pool_reader &
+      (context_hdl%daddr, default_pool_reader_, len(default_pool_reader_))
+      ENDIF
+
+      IF (PRESENT(default_pool_writer_)) THEN
+        CALL cxios_set_context_default_pool_writer &
+      (context_hdl%daddr, default_pool_writer_, len(default_pool_writer_))
+      ENDIF
+
+      IF (PRESENT(default_reader_)) THEN
+        CALL cxios_set_context_default_reader &
+      (context_hdl%daddr, default_reader_, len(default_reader_))
+      ENDIF
+
+      IF (PRESENT(default_using_server2_)) THEN
+        default_using_server2__tmp = default_using_server2_
+        CALL cxios_set_context_default_using_server2 &
+      (context_hdl%daddr, default_using_server2__tmp)
+      ENDIF
+
+      IF (PRESENT(default_writer_)) THEN
+        CALL cxios_set_context_default_writer &
+      (context_hdl%daddr, default_writer_, len(default_writer_))
+      ENDIF
+
       IF (PRESENT(output_dir_)) THEN
         CALL cxios_set_context_output_dir &
@@ -65,5 +139,6 @@
 
   SUBROUTINE xios(get_context_attr)  &
-    ( context_id, attached_mode, output_dir )
+    ( context_id, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -72,4 +147,13 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: attached_mode
       LOGICAL (KIND=C_BOOL) :: attached_mode_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_reader
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_writer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_reader
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: default_using_server2
+      LOGICAL (KIND=C_BOOL) :: default_using_server2_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_writer
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: output_dir
 
@@ -77,10 +161,12 @@
       (context_id,context_hdl)
       CALL xios(get_context_attr_hdl_)   &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(get_context_attr)
 
   SUBROUTINE xios(get_context_attr_hdl)  &
-    ( context_hdl, attached_mode, output_dir )
+    ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -88,13 +174,25 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: attached_mode
       LOGICAL (KIND=C_BOOL) :: attached_mode_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_gatherer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_reader
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_writer
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_reader
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: default_using_server2
+      LOGICAL (KIND=C_BOOL) :: default_using_server2_tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_writer
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: output_dir
 
       CALL xios(get_context_attr_hdl_)  &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(get_context_attr_hdl)
 
   SUBROUTINE xios(get_context_attr_hdl_)   &
-    ( context_hdl, attached_mode_, output_dir_ )
+    ( context_hdl, attached_mode_, default_gatherer_, default_pool_, default_pool_gatherer_, default_pool_reader_  &
+    , default_pool_writer_, default_reader_, default_using_server2_, default_writer_, output_dir_  &
+     )
 
     IMPLICIT NONE
@@ -102,4 +200,13 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: attached_mode_
       LOGICAL (KIND=C_BOOL) :: attached_mode__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_gatherer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_gatherer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_reader_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_pool_writer_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_reader_
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: default_using_server2_
+      LOGICAL (KIND=C_BOOL) :: default_using_server2__tmp
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: default_writer_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: output_dir_
 
@@ -110,4 +217,45 @@
       ENDIF
 
+      IF (PRESENT(default_gatherer_)) THEN
+        CALL cxios_get_context_default_gatherer &
+      (context_hdl%daddr, default_gatherer_, len(default_gatherer_))
+      ENDIF
+
+      IF (PRESENT(default_pool_)) THEN
+        CALL cxios_get_context_default_pool &
+      (context_hdl%daddr, default_pool_, len(default_pool_))
+      ENDIF
+
+      IF (PRESENT(default_pool_gatherer_)) THEN
+        CALL cxios_get_context_default_pool_gatherer &
+      (context_hdl%daddr, default_pool_gatherer_, len(default_pool_gatherer_))
+      ENDIF
+
+      IF (PRESENT(default_pool_reader_)) THEN
+        CALL cxios_get_context_default_pool_reader &
+      (context_hdl%daddr, default_pool_reader_, len(default_pool_reader_))
+      ENDIF
+
+      IF (PRESENT(default_pool_writer_)) THEN
+        CALL cxios_get_context_default_pool_writer &
+      (context_hdl%daddr, default_pool_writer_, len(default_pool_writer_))
+      ENDIF
+
+      IF (PRESENT(default_reader_)) THEN
+        CALL cxios_get_context_default_reader &
+      (context_hdl%daddr, default_reader_, len(default_reader_))
+      ENDIF
+
+      IF (PRESENT(default_using_server2_)) THEN
+        CALL cxios_get_context_default_using_server2 &
+      (context_hdl%daddr, default_using_server2__tmp)
+        default_using_server2_ = default_using_server2__tmp
+      ENDIF
+
+      IF (PRESENT(default_writer_)) THEN
+        CALL cxios_get_context_default_writer &
+      (context_hdl%daddr, default_writer_, len(default_writer_))
+      ENDIF
+
       IF (PRESENT(output_dir_)) THEN
         CALL cxios_get_context_output_dir &
@@ -118,5 +266,6 @@
 
   SUBROUTINE xios(is_defined_context_attr)  &
-    ( context_id, attached_mode, output_dir )
+    ( context_id, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -125,4 +274,20 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: attached_mode
       LOGICAL(KIND=C_BOOL) :: attached_mode_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_gatherer
+      LOGICAL(KIND=C_BOOL) :: default_gatherer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool
+      LOGICAL(KIND=C_BOOL) :: default_pool_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_gatherer
+      LOGICAL(KIND=C_BOOL) :: default_pool_gatherer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_reader
+      LOGICAL(KIND=C_BOOL) :: default_pool_reader_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_writer
+      LOGICAL(KIND=C_BOOL) :: default_pool_writer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_reader
+      LOGICAL(KIND=C_BOOL) :: default_reader_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_using_server2
+      LOGICAL(KIND=C_BOOL) :: default_using_server2_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_writer
+      LOGICAL(KIND=C_BOOL) :: default_writer_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: output_dir
       LOGICAL(KIND=C_BOOL) :: output_dir_tmp
@@ -131,10 +296,12 @@
       (context_id,context_hdl)
       CALL xios(is_defined_context_attr_hdl_)   &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(is_defined_context_attr)
 
   SUBROUTINE xios(is_defined_context_attr_hdl)  &
-    ( context_hdl, attached_mode, output_dir )
+    ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+    , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
     IMPLICIT NONE
@@ -142,14 +309,33 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: attached_mode
       LOGICAL(KIND=C_BOOL) :: attached_mode_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_gatherer
+      LOGICAL(KIND=C_BOOL) :: default_gatherer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool
+      LOGICAL(KIND=C_BOOL) :: default_pool_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_gatherer
+      LOGICAL(KIND=C_BOOL) :: default_pool_gatherer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_reader
+      LOGICAL(KIND=C_BOOL) :: default_pool_reader_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_writer
+      LOGICAL(KIND=C_BOOL) :: default_pool_writer_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_reader
+      LOGICAL(KIND=C_BOOL) :: default_reader_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_using_server2
+      LOGICAL(KIND=C_BOOL) :: default_using_server2_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_writer
+      LOGICAL(KIND=C_BOOL) :: default_writer_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: output_dir
       LOGICAL(KIND=C_BOOL) :: output_dir_tmp
 
       CALL xios(is_defined_context_attr_hdl_)  &
-      ( context_hdl, attached_mode, output_dir )
+      ( context_hdl, attached_mode, default_gatherer, default_pool, default_pool_gatherer, default_pool_reader  &
+      , default_pool_writer, default_reader, default_using_server2, default_writer, output_dir )
 
   END SUBROUTINE xios(is_defined_context_attr_hdl)
 
   SUBROUTINE xios(is_defined_context_attr_hdl_)   &
-    ( context_hdl, attached_mode_, output_dir_ )
+    ( context_hdl, attached_mode_, default_gatherer_, default_pool_, default_pool_gatherer_, default_pool_reader_  &
+    , default_pool_writer_, default_reader_, default_using_server2_, default_writer_, output_dir_  &
+     )
 
     IMPLICIT NONE
@@ -157,4 +343,20 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: attached_mode_
       LOGICAL(KIND=C_BOOL) :: attached_mode__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_gatherer_
+      LOGICAL(KIND=C_BOOL) :: default_gatherer__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_
+      LOGICAL(KIND=C_BOOL) :: default_pool__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_gatherer_
+      LOGICAL(KIND=C_BOOL) :: default_pool_gatherer__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_reader_
+      LOGICAL(KIND=C_BOOL) :: default_pool_reader__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_pool_writer_
+      LOGICAL(KIND=C_BOOL) :: default_pool_writer__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_reader_
+      LOGICAL(KIND=C_BOOL) :: default_reader__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_using_server2_
+      LOGICAL(KIND=C_BOOL) :: default_using_server2__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: default_writer_
+      LOGICAL(KIND=C_BOOL) :: default_writer__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: output_dir_
       LOGICAL(KIND=C_BOOL) :: output_dir__tmp
@@ -166,4 +368,52 @@
       ENDIF
 
+      IF (PRESENT(default_gatherer_)) THEN
+        default_gatherer__tmp = cxios_is_defined_context_default_gatherer &
+      (context_hdl%daddr)
+        default_gatherer_ = default_gatherer__tmp
+      ENDIF
+
+      IF (PRESENT(default_pool_)) THEN
+        default_pool__tmp = cxios_is_defined_context_default_pool &
+      (context_hdl%daddr)
+        default_pool_ = default_pool__tmp
+      ENDIF
+
+      IF (PRESENT(default_pool_gatherer_)) THEN
+        default_pool_gatherer__tmp = cxios_is_defined_context_default_pool_gatherer &
+      (context_hdl%daddr)
+        default_pool_gatherer_ = default_pool_gatherer__tmp
+      ENDIF
+
+      IF (PRESENT(default_pool_reader_)) THEN
+        default_pool_reader__tmp = cxios_is_defined_context_default_pool_reader &
+      (context_hdl%daddr)
+        default_pool_reader_ = default_pool_reader__tmp
+      ENDIF
+
+      IF (PRESENT(default_pool_writer_)) THEN
+        default_pool_writer__tmp = cxios_is_defined_context_default_pool_writer &
+      (context_hdl%daddr)
+        default_pool_writer_ = default_pool_writer__tmp
+      ENDIF
+
+      IF (PRESENT(default_reader_)) THEN
+        default_reader__tmp = cxios_is_defined_context_default_reader &
+      (context_hdl%daddr)
+        default_reader_ = default_reader__tmp
+      ENDIF
+
+      IF (PRESENT(default_using_server2_)) THEN
+        default_using_server2__tmp = cxios_is_defined_context_default_using_server2 &
+      (context_hdl%daddr)
+        default_using_server2_ = default_using_server2__tmp
+      ENDIF
+
+      IF (PRESENT(default_writer_)) THEN
+        default_writer__tmp = cxios_is_defined_context_default_writer &
+      (context_hdl%daddr)
+        default_writer_ = default_writer__tmp
+      ENDIF
+
       IF (PRESENT(output_dir_)) THEN
         output_dir__tmp = cxios_is_defined_context_output_dir &
